<?php

/**
 * Reminder plugin
 *
 *
 * Created: 2007-02-04
 * Last update: 2007-02-24
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

define( 'PLUGINS_REMINDER_ENABLE_DEFAULT', OFF );
define( 'PLUGINS_REMINDER_HTML_ENABLE_DEFAULT', OFF );
define( 'PLUGINS_REMINDER_HTML_HOST_DEFAULT', '' );
define( 'PLUGINS_REMINDER_FORMAT_DEFAULT', 0 );
define( 'PLUGINS_REMINDER_SUBJECT_TITLE_DEFAULT', 'Automatic reminder' );
define( 'PLUGINS_REMINDER_ASSIGNED_DEFAULT', '1,7,14' );
define( 'PLUGINS_REMINDER_FEEDBACK_DEFAULT', '2,7,14' );
define( 'PLUGINS_REMINDER_UNASSIGNED_DEFAULT', '3,7,14' );
define( 'PLUGINS_REMINDER_DEADLINE_DEFAULT', '4,7,14' );
define( 'PLUGINS_REMINDER_BUGS_ID_DEFAULT', '' );
define( 'PLUGINS_REMINDER_DATES_DEFAULT', 'wday=>0;wday=>6;mon=>12,mday=>25;mon=>5,mday=>1;mon=>11,mday=>11;mon=>11,mday=>1;mon=>7,mday=>14;mon=>8,mday=>15;mon=>5,mday=>8;mon=>1,mday=>1' );
define( 'PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT', 0 );
define( 'PLUGINS_REMINDER_DEADLINE_DEFAULT', 5 );

define( 'REMINDER_HTML', 1 );
define( 'REMINDER_TEXT', 0 );
define( 'REMINDER_TEXT_HTML', 2 );

$t_core_path = config_get( 'core_path' );
require_once( $t_core_path . 'icon_api.php' );

function reminder_get_bugs( &$p_send, &$p_send_excepted, $p_type, $p_project_id, $p_format, $p_user_id, $p_date ) {
    switch( $p_type ) {
      case 'unassigned':
        $t_query1 = 'SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.date_submitted FROM ' . config_get( 'mantis_bug_table' ) . ' b WHERE b.handler_id=0 AND b.date_submitted<\'' . date( 'Y-m-d 23:59:59', time() - $p_date[0] * 60 * 60 * 24 ) . '\' AND b.date_submitted>\'' . date( 'Y-m-d 00:00:00', time() - $p_date[0] * 60 * 60 * 24 ) . '\'';
        $t_query2 = 'SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.date_submitted FROM ' . config_get( 'mantis_bug_table' ) . ' b WHERE b.handler_id=0 AND b.date_submitted<\'' . date( 'Y-m-d 23:59:59', time() - $p_date[1] * 60 * 60 * 24 ) . '\'';
        $t_url_link_parameters = 'handler_id=[none]';
        break;
      case 'feedback':
        $t_query1 = 'SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, h.date_modified FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_bug_history_table' ) . ' h ON h.bug_id = b.id WHERE h.field_name=\'status\' AND h.new_value=' . FEEDBACK . ' AND h.date_modified>\'' . date( 'Y-m-d 00:00:00', time() - $p_date[0] * 60 * 60 * 24 ) . '\' AND b.status=' . FEEDBACK . ' AND h.date_modified<\'' . date( 'Y-m-d 23:59:59', time() - $p_date[0] * 60 * 60 * 24 ) . '\' AND b.reporter_id=' . $p_user_id;
        $t_query2 = 'SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, h.date_modified FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_bug_history_table' ) . ' h ON h.bug_id = b.id WHERE h.field_name=\'status\' AND h.new_value=' . FEEDBACK . ' AND b.status=' . FEEDBACK . ' AND h.date_modified<\'' . date( 'Y-m-d 23:59:59', time() - $p_date[1] * 60 * 60 * 24 ) . '\' AND b.reporter_id=' . $p_user_id;
        $t_url_link_parameters = 'show_status=' . FEEDBACK;
        break;
      case 'assigned':
        $t_query1 = 'SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, h.date_modified FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_bug_history_table' ) . ' h ON h.bug_id = b.id WHERE h.field_name=\'handler_id\' AND h.date_modified>\'' . date( 'Y-m-d 00:00:00', time() - $p_date[0] * 60 * 60 * 24 ) . '\' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND h.date_modified<\'' . date( 'Y-m-d 23:59:59', time() - $p_date[0] * 60 * 60 * 24 ) . '\' AND b.handler_id=' . $p_user_id;
        $t_query2 = 'SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, h.date_modified FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_bug_history_table' ) . ' h ON h.bug_id = b.id WHERE h.field_name=\'handler_id\' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND h.date_modified<\'' . date( 'Y-m-d 23:59:59', time() - $p_date[1] * 60 * 60 * 24 ) . '\' AND b.handler_id=' . $p_user_id;
        $t_url_link_parameters = 'handler_id=' . $p_user_id . '&amp;hide_status=' . RESOLVED;
        break;
      case 'deadline':
        if ( $p_project_id == 0 ) {
            $t_query = 'DROP TABLE IF EXISTS plugins_reminder_query_one_table, plugins_reminder_query_two_table';
            db_query( $t_query );
            $t_projects = project_get_all_rows();
            $t_query1 = 'CREATE TEMPORARY TABLE plugins_reminder_query_one_table SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.handler_id, c.value, b.reporter_id FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_custom_field_string_table' ) . ' c ON c.bug_id=b.id WHERE c.field_id=' . config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT, NO_USER, $t_projects[0] ) . ' AND b.project_id=' . $t_projects[0] . ' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND c.value=\'' . ( time() + $p_date[0] * 60 * 60 * 24 ) . '\'';
            $t_query2 = 'CREATE TEMPORARY TABLE plugins_reminder_query_two_table SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.handler_id, c.value, b.reporter_id FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_custom_field_string_table' ) . ' c ON c.bug_id=b.id WHERE c.field_id=' . config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT, NO_USER, $t_projects[0] ) . ' AND b.project_id=' . $t_projects[0] . ' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND c.value<=\'' . ( time() + $p_date[1] * 60 * 60 * 24 ) . '\'';
            db_query( $t_query1 );
            db_query( $t_query2 );
            for( $i=1; $i<count( $t_projects ); $i++ ) {
                $t_query1 = 'INSERT INTO plugins_reminder_query_one_table SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.handler_id, c.value, b.reporter_id FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_custom_field_string_table' ) . ' c ON c.bug_id=b.id WHERE c.field_id=' . config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT, NO_USER, $t_projects[$i] ) . ' AND b.project_id=' . $t_projects[$i] . ' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND c.value=\'' . ( time() + $p_date[0] * 60 * 60 * 24 ) . '\'';
                $t_query2 = 'INSERT INTO plugins_reminder_query_two_table SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.handler_id, c.value, b.reporter_id FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_custom_field_string_table' ) . ' c ON c.bug_id=b.id WHERE c.field_id=' . config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT, NO_USER, $t_projects[$i] ) . ' AND b.project_id=' . $t_projects[$i] . ' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND c.value<=\'' . ( time() + $p_date[1] * 60 * 60 * 24 ) . '\'';
                db_query( $t_query1 );
                db_query( $t_query2 );
            }
            $t_query1 = 'SELECT * FROM plugins_reminder_query_one_table b WHERE ( b.handler_id=' . $p_user_id . ' AND b.status<>' . FEEDBACK . ' ) OR ( b.handler_id=0 AND b.reporter_id=' . $p_user_id . ' ) OR ( b.status=' . FEEDBACK . ' AND b.reporter_id=' . $p_user_id . ' )';
            $t_query2 = 'SELECT * FROM plugins_reminder_query_two_table b WHERE ( b.handler_id=' . $p_user_id . ' AND b.status<>' . FEEDBACK . ' ) OR ( b.handler_id=0 AND b.reporter_id=' . $p_user_id . ' ) OR ( b.status=' . FEEDBACK . ' AND b.reporter_id=' . $p_user_id . ' )';
        } else {
            $t_query = 'DROP TABLE IF EXISTS plugins_reminder_query_one_table, plugins_reminder_query_two_table';
            db_query( $t_query );
            $t_query1 = 'CREATE TEMPORARY TABLE plugins_reminder_query_one_table SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.handler_id, c.value, b.reporter_id FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_custom_field_string_table' ) . ' c ON c.bug_id=b.id WHERE c.field_id=' . config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT, NO_USER, $p_project_id ) . ' AND b.project_id=' . $p_project_id . ' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND c.value=\'' . ( time() + $p_date[0] * 60 * 60 * 24 ) . '\'';
            $t_query2 = 'CREATE TEMPORARY TABLE plugins_reminder_query_two_table SELECT b.id, b.summary, b.last_updated, b.view_state, b.status, b.project_id, b.priority, b.category, b.handler_id, c.value, b.reporter_id FROM ' . config_get( 'mantis_bug_table' ) . ' b LEFT JOIN ' . config_get( 'mantis_custom_field_string_table' ) . ' c ON c.bug_id=b.id WHERE c.field_id=' . config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT, NO_USER, $p_project_id ) . ' AND b.project_id=' . $p_project_id . ' AND b.status<' . config_get( 'bug_resolved_status_threshold' ) . ' AND c.value<=\'' . ( time() + $p_date[1] * 60 * 60 * 24 ) . '\'';
            db_query( $t_query1 );
            db_query( $t_query2 );
            $t_query1 = 'SELECT * FROM plugins_reminder_query_one_table b WHERE ( b.handler_id=' . $p_user_id . ' AND b.status<>' . FEEDBACK . ' ) OR ( b.handler_id=0 AND b.reporter_id=' . $p_user_id . ' ) OR ( b.status=' . FEEDBACK . ' AND b.reporter_id=' . $p_user_id . ' )';
            $t_query2 = 'SELECT * FROM plugins_reminder_query_two_table b WHERE ( b.handler_id=' . $p_user_id . ' AND b.status<>' . FEEDBACK . ' ) OR ( b.handler_id=0 AND b.reporter_id=' . $p_user_id . ' ) OR ( b.status=' . FEEDBACK . ' AND b.reporter_id=' . $p_user_id . ' )';
        }
        $t_url_link_parameters = 'hide_status=none';
        break;
      default:
        $t_url_link_parameters = 'hide_status=none';
        break;
    }

    $t_bugs_id = explode( ';', config_get( 'plugins_reminder_bugs_id', PLUGINS_REMINDER_BUGS_ID_DEFAULT ) );
    foreach( $t_bugs_id as $t_id ) {
        $t_id = (int)trim( $t_id );
        $t_query1 .= ' AND b.id<>' . $t_id;
        $t_query2 .= ' AND b.id<>' . $t_id;
    }
    
    $t_path = config_get( 'path' );
    $t_icon_path = config_get( 'icon_path' );
    $t_update_bug_threshold = config_get( 'update_bug_threshold' );
    $t_rows = array();
    if ( isset( $t_query1 ) ) {
        if ( is_array( $p_project_id ) ) {
            $t_query1 .= ' AND ( ';
            for( $i=0; $i<count( $p_project_id ); $i++ ) {
                if ( $i == 0 ) {
                    $t_query1 .= 'b.project_id=' . $p_project_id[$i];
                } else {
                    $t_query1 .= ' OR b.project_id=' . $p_project_id[$i];
                }
            }
            $t_query1 .= ' )';
        } elseif ( $p_project_id != 0 ) {
            $t_query1 .= ' AND b.project_id=' . $p_project_id;
        }
        $t_query1 .= ' ORDER BY b.last_updated DESC';
        $result = db_query( $t_query1 );
        while( $row = db_fetch_array( $result ) ) {
            $row['last_updated'] = db_unixtimestamp( $row['last_updated'] );
            $row['date_modified'] = db_unixtimestamp( $row['date_modified'] );
            $row['date_submitted'] = db_unixtimestamp( $row['date_submitted'] );
            $t_rows[] = $row;
        }
    }
    if ( count( $t_rows ) != 0 ) {
        $p_send_excepted = true;
        $p_send = true;
    }
    if ( isset( $t_query2 ) ) {
        if ( is_array( $p_project_id ) ) {
            $t_query2 .= ' AND ( ';
            for( $i=0; $i<count( $p_project_id ); $i++ ) {
                if ( $i == 0 ) {
                    $t_query2 .= 'b.project_id=' . $p_project_id[$i];
                } else {
                    $t_query2 .= ' OR b.project_id=' . $p_project_id[$i];
                }
            }
            $t_query2 .= ' )';
        } elseif ( $p_project_id != 0 ) {
            $t_query2 .= ' AND b.project_id=' . $p_project_id;
        }
        $t_query2 .= ' ORDER BY b.last_updated DESC';
        $result = db_query( $t_query2 );
        while( $row = db_fetch_array( $result ) ) {
            $row['last_updated'] = db_unixtimestamp( $row['last_updated'] );
            $row['date_modified'] = db_unixtimestamp( $row['date_modified'] );
            $row['date_submitted'] = db_unixtimestamp( $row['date_submitted'] );
            $t_rows[] = $row;
            $p_send = true;
        }
    }
    
    $t_box_title = lang_get( 'my_view_title_' . $p_type );
    if ( $p_format == 'html' ) {
        $t_result = '<table class="width100" cellspacing="1">' . "\n";
        $t_result .= "<tr>\n<td class=\"form-title\" colspan=\"2\">\n";
        $t_result .= '<a class="subtle" href="' . $t_path . 'view_all_set.php?type=1&amp;temporary=y&amp;' . $t_url_link_parameters . '">';
        $t_result .= $t_box_title . '</a>' . ' [';
        $t_result .= '<a class="subtle" href="' . $t_path . 'view_all_set.php?type=1&amp;temporary=y&amp;' . $t_url_link_parameters . '" target="_blank">';
	$t_result .= '^' . '</a>]';
        if ( sizeof( $t_rows ) > 0 ) {
            $v_start = 1;
            $v_end   = $v_start + sizeof( $t_rows ) - 1;
        } else {
            $v_start = 0;
            $v_end   = 0;
        }
        $t_result .= " ($v_start - $v_end / $v_end)";
        $t_result .= "\n</td>\n</tr>\n";
	for( $i=0; $i<sizeof( $t_rows ); $i++ ) {
            extract( $t_rows[$i], EXTR_PREFIX_ALL, 'v' );

            $t_summary = string_attribute( $v_summary );
            $t_last_updated = date( config_get( 'normal_date_format' ), $v_last_updated );

            $t_status_color = get_status_color( $v_status );

            $t_attachment_count = 0;
            if (  ( file_can_view_bug_attachments( $v_id ) ) ) {
                $t_attachment_count = file_bug_attachment_count( $v_id );
            }

            $t_project_name = project_get_field( $v_project_id, 'name' );
            $t_result .= "<tr bgcolor=\"$t_status_color\">\n";
            $t_result .= "<td class=\"center\" valign=\"top\" width =\"0\" nowrap>\n";
            $t_result .= '<span class="small">';
            $t_result .= string_get_bug_view_link( $v_id, null, true, true ) . '<br />';

            if ( !bug_is_readonly( $v_id ) && access_has_bug_level( $t_update_bug_threshold, $v_id ) ) {
                $t_result .= '<a href="' . $t_path . string_get_bug_update_url( $v_id ) . '"><img border="0" src="' . $t_icon_path . 'update.png' . '" alt="' . lang_get( 'update_bug_button' ) . '" /></a>';
            }
            $t_result .= icon_get_status_icon( $v_priority );
            if ( 0 < $t_attachment_count ) {
                $t_result .= '<a href="' . $t_path . string_get_bug_view_url( $v_id ) . '#attachments">';
                $t_result .= '<img border="0" src="' . $t_icon_path . 'attachment.png' . '"';
                $t_result .= ' alt="' . lang_get( 'attachment_alt' ) . '"';
                $t_result .= ' title="' . $t_attachment_count . ' ' . lang_get( 'attachments' ) . '"';
                $t_result .= ' />' . '</a>';
            }
            if ( VS_PRIVATE == $v_view_state ) {
                $t_result .= '<img src="' . $t_icon_path . 'protected.gif" width="8" height="15" alt="' . lang_get( 'private' ) . '" />';
            }
            $t_result .= '</span></td>';
            $t_result .= '<td class="left" valign="top" width="100%"><span class="small">';
            $t_result .= $t_summary;
            $t_result .= "<br />\n";
            if ( ON == config_get( 'show_bug_project_links' ) && ( $p_project_id == 0 || $p_type == 'unassigned' ) ) {
                $t_result .= '[' . $t_project_name . '] ';
            }
            $t_result .= string_display( $v_category );
            if ( $v_last_updated > strtotime( '-' . config_get( 'default_show_changed' ) . ' hours' ) ) {
                $t_result .= ' - <b>' . $t_last_updated . '</b>';
            } else {
                $t_result .= ' - ' . $t_last_updated;
            }
            switch( $p_type ) {
              case 'unassigned':
                $t_date = (int)( ( time() - $v_date_submitted ) / ( 60 * 60 * 24 ) );
                $t_result .= ' - <b>' . $t_date . '</b> ' . lang_get( 'plugins_reminder_days' );
                break;
              case 'assigned':
              case 'feedback':
                $t_date = (int)( ( time() - $v_date_modified ) / ( 60 * 60 * 24 ) );
                $t_result .= ' - <b>' . $t_date . '</b> ' . lang_get( 'plugins_reminder_days' );
                break;
              case 'deadline':
                $t_date = (int)( ( intval( $v_value ) - time() ) / ( 60 * 60 * 24 ) );
                $t_result .= ' - <b>';
                if ( $t_date < 0 ) {
                    $t_result .= '<font color="red">';
                }
                $t_result .= $t_date;
                if ( $t_date < 0 ) {
                    $t_result .= '</font>';
                }
                $t_result .= '</b> ' . lang_get( 'plugins_reminder_days' ) . ' ' . lang_get( 'plugins_reminder_remaining' );
                break;
              default:
                break;
            }
            $t_result .= '</span></td></tr>';
	}
        $t_result .= '</table>';
    } else {
        $t_title = $t_box_title;
        $t_link = '<' . $t_path . 'view_all_set.php?type=1&amp;temporary=y&amp;' . $t_url_link_parameters . '>';
        if ( sizeof( $t_rows ) > 0 ) {
            $v_start = 1;
            $v_end   = $v_start + sizeof( $t_rows ) - 1;
        } else {
            $v_start = 0;
            $v_end   = 0;
        }
        $t_title .= '    (' . $v_start . ' - ' . $v_end . ' / ' . $v_end . ')';
        $t_result = "\n" . $t_title . "\n" . $t_link . "\n";
        $t_result .= str_pad( '', max( strlen( $t_title ), strlen( $t_link ) ), '-' ) . "\n";
	for( $i=0; $i<sizeof( $t_rows ); $i++ ) {
            extract( $t_rows[$i], EXTR_PREFIX_ALL, 'v' );

            $t_last_updated = date( config_get( 'normal_date_format' ), $v_last_updated );

            $t_project_name = project_get_field( $v_project_id, 'name' );
            $t_result .= ' * ' . bug_format_id( $v_id ) . ': ';
            $t_result .= $v_summary . "\n";
            $t_result .= '            ';
            if ( ON == config_get( 'show_bug_project_links' ) && ( $p_project_id == 0 || $p_type == 'unassigned' ) ) { 
                $t_result .= '[' . $t_project_name . '] ';
            }           
            $t_result .= string_display( $v_category );
            $t_result .= ' - ' . $t_last_updated;
            switch( $p_type ) {
              case 'unassigned':
                $t_date = (int)( ( time() - $v_date_submitted ) / ( 60 * 60 * 24 ) );
                $t_result .= ' - *' . $t_date . '* ' . lang_get( 'plugins_reminder_days' );
                break;
              case 'assigned':
              case 'feedback':
                $t_date = (int)( ( time() - $v_date_modified ) / ( 60 * 60 * 24 ) );
                $t_result .= ' - *' . $t_date . '* ' . lang_get( 'plugins_reminder_days' );
                break;
              case 'deadline':
                $t_date = (int)( ( intval( $v_value ) - time() ) / ( 60 * 60 * 24 ) );
                $t_result .= ' - *' . $t_date . '* ' . lang_get( 'plugins_reminder_days' ) . ' ' . lang_get( 'plugins_reminder_remaining' );
                break;
              default:
                break;
            }
            $t_result .= "\n";
            $t_result .= '   <' . $t_path . string_get_bug_view_url( $v_id ) . ">\n\n";
	}
        $t_result .= "\n";
    }
    
    return $t_result;
}

function reminder_get_body( &$p_send, &$p_send_excepted, $p_user_id, $p_format, $p_project_id ) {
    $t_project_id = $p_project_id;
    $t_boxes = config_get( 'plugins_reminder_view_boxes', array( 'assigned' => PLUGINS_REMINDER_ASSIGNED_DEFAULT, 'unassigned' => PLUGINS_REMINDER_UNASSIGNED_DEFAULT, 'feedback' => PLUGINS_REMINDER_FEEDBACK_DEFAULT ), $p_user_id, $t_project_id );
    asort( $t_boxes );
    reset( $t_boxes );
    $t_title = config_get( 'plugins_reminder_subject_title', PLUGINS_REMINDER_SUBJECT_TITLE_DEFAULT, $p_user_id, $t_project_id );

    if ( $p_format == 'html' ) {
        $t_result = '<html><head>';
        $t_css_url = config_get( 'css_include_file' );
        $t_result .= '<link rel="stylesheet" type="text/css" href="' . $t_css_url . '" />' . "\n";
        $t_result .= "\t" . '<script type="text/javascript" language="JavaScript"><!--' . "\n";
        $t_result .= "\t\t" . 'if(document.layers) {document.write("<style>td{padding:0px;}<\/style>")}' . "\n";
        $t_result .= "\t" . '// --></script>' . "\n";
        $t_result .= '<title>' . $t_title . '</title>' . "\n";
        $t_result .= '</head><body>';
        $t_result .= '<div align="center">';
        $t_result .= '<span class="pagetitle">' . $t_title . '</span><br /><br />' . "\n";
        $t_result .= '<table class="hide" border="0" cellspacing="3" cellpadding="0">';
    } else {
        $t_result = $t_title . "\n";
        $t_text = '';
        $t_result .= str_pad( $t_text, strlen( $t_title ), '=' ) . "\n\n";
    }

    $t_number_of_boxes = count ( $t_boxes );
    $t_counter = 0;
    while( list( $t_box_title, $t_box_display ) = each( $t_boxes ) ) {
        $t_box_display = explode( ',', $t_box_display );
        $t_date[0] = $t_box_display[1];
        $t_date[1] = $t_box_display[2];
        $t_box_display = $t_box_display[0];
        $t_project_list = $t_project_id;
        if ( $t_box_title == 'unassigned' ) {
            $t_update_bug_assign_threshold = config_get( 'update_bug_assign_threshold', DEVELOPER, NO_USER, $t_project_id );
            if ( $t_project_id == 0 ) {
                $query = 'SELECT project_id FROM ' . config_get( 'mantis_project_user_list_table' ) . ' WHERE user_id=' . $p_user_id . ' AND ';
                if ( is_array( $t_update_bug_assign_threshold ) ) {
                    $query .= '( ';
                    for( $i=0; $i<count( $t_update_bug_assign_threshold ); $i++ ) {
                        if ( $i == 0 ) {
                            $query .= 'access_level=' . $t_update_bug_assign_threshold[$i];
                        } else {
                            $query .= ' OR access_level=' . $t_update_bug_assign_threshold[$i];
                        }
                    }
                    $query .= ' )';
                } else {
                    $query .= ' access_level>=' . $t_update_bug_assign_threshold;
                }
                $result = db_query( $query );
                $t_project_list = array();
                while( $row = db_fetch_array( $result ) ) {
                    $t_project_list[] = $row['project_id'];
                }
                if ( count( $t_project_list ) == 0 ) {
                    $t_box_display = 0;
                }
            } else {
                $query = 'SELECT access_level FROM ' . config_get( 'mantis_project_user_list_table' ) . ' WHERE project_id=' . $t_project_id . ' AND user_id=' . $p_user_id;
                $result = db_query( $query );
                if ( db_num_rows( $result ) == 1 ) {
                    $row = db_fetch_array( $result );
                    if ( is_array( $t_update_bug_assign_threshold ) ) {
                        if ( !in_array( $row['access_level'], $t_update_bug_assign_threshold ) ) {
                            $t_box_display = 0;
                        } elseif ( $row['access_level'] < $t_update_bug_assign_threshold ) {
                            $t_box_display = 0;
                        }
                    }
                } else {
                    $t_box_display = 0;
                }
            }
        }
        if ( $t_box_display == 0 ) {
            $t_number_of_boxes = $t_number_of_boxes - 1;
        } else {
            $t_counter++;
            if ( 1 == $t_counter%2 ) {
                if ( $p_format == 'html' ) {
                    $t_result .= '<tr><td valign="top" width="50%">';
                }
                $t_result .= reminder_get_bugs( $p_send, $p_send_excepted, $t_box_title, $t_project_list, $p_format, $p_user_id, $t_date );
                if ( $p_format == 'html' ) {
                    $t_result .= '</td>';
                }               
            } elseif ( 0 == $t_counter % 2 ) {
                if ( $p_format == 'html' ) {
                    $t_result .= '<td valign="top" width="50%">';
                }               
                $t_result .= reminder_get_bugs( $p_send, $p_send_excepted, $t_box_title, $t_project_list, $p_format, $p_user_id, $t_date );
                if ( $p_format == 'html' ) {
                    $t_result .= '</td></tr>';
                }               
            }
            if ( $p_format == 'html' && ( $t_counter == $t_number_of_boxes ) && 1 == $t_counter % 2 ) {
                $t_result .= '<td valign="top" width="50%"></td></tr>';
            }
        }
    }

    if ( $p_format == 'html' ) {
        $t_result .= '</table></div>';
        $t_result .= '<hr size="1" />';
        $t_result .= '<table border="0" width="100%" cellspacing="0" cellpadding="0"><tr valign="top"><td>';
        $t_result .= '<address><a href="mailto:' . config_get( 'webmaster_email' ) . '">' . config_get( 'webmaster_email' ) . '</a></address>';
        $t_result .= '</td><td></td></tr></table>';
        $t_result .= '</body></html>';
    }

    return $t_result;
}

?>
